package org.openjdk.gcbench.retain;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(Threads.MAX)
@State(Scope.Benchmark)
public class Finalizables {

    Object retain;

    @Param({"100000"})
    private int size;

    @Setup
    public void setup() {
        Object[] objs = new Object[size];
        for (int c = 0; c < size; c++) {
            objs[c] = new Finalizable();
        }
        retain = objs;
    }

    @Benchmark
    public Object test() {
        return new Object();
    }

    public static class Finalizable {
        @Override
        protected void finalize() throws Throwable {
            super.finalize();
        }
    }

}
